doctype html
html(lang='de')
    head
        meta(charset='utf-8')
        title Terminvergabe
        script(src="https://ajaxorg.github.io/ace-builds/src-min-noconflict/ace.js")
        script(src="https://cdnjs.cloudflare.com/ajax/libs/ace/1.4.6/theme-monokai.js")
        script(src="https://cdnjs.cloudflare.com/ajax/libs/ace/1.4.6/mode-javascript.js")
        script
            include scripts.js
        style
            include style.css
        meta(name='viewport', content='width=device-width, initial-scale=1.0')
    body
        h2
        table(id='terminliste')
            thead
                th Zettel
                th Datum
                th Zeit
                th Auslastung
                th Anmeldungen
            tbody
                each termin in termine
                    -
                        termin.dateString = new Date(termin.beginTime).toLocaleDateString("de")
                        termin.fromString = new Date(termin.beginTime).toLocaleTimeString("de", {hour: "2-digit", minute: "2-digit"})
                        termin.toString = new Date(termin.beginTime + termin.duration).toLocaleTimeString("de", {hour: "2-digit", minute: "2-digit"})
                    tr
                        td #{termin.weekNumber}
                        td #{termin.dateString}
                        td #{termin.fromString} - #{termin.toString}
                        td #{termin.appointments.length}/#{termin.amount}
                        td #{termin.appointments.join(", ")}
        h2 Neue Termine hinzufügen:
        div(id='editor', style="min-height: 150px;")
        br
        button(onclick="preview()") Vorschau aktualisieren
        button(onclick="termineHinzufügen()") Termine hinzufügen (verbindlich)
        h3 Vorschau:
        div(id='preview')
            br
        p Sie sind eingeloggt als #{username}.
    script.
        window.editor = ace.edit("editor");
        editor.setTheme("ace/theme/monokai");
        editor.session.setMode("ace/mode/javascript");
        editor.setValue(`params = {
            startDatum: "2019-11-25", // ein Montag im Format YYYY-MM-DD
            übungszettelnummer: 1, // ein int > 0
            startZeiten: [7, 17], // Wann beginnen die Testate jeden Tag?; Zeit in h seit 00:00 GMT (!!!)
            vorbereitungszeit: 10 * 60 * 1000, // 10min * 60s * 1000ms
            testatLänge: 20 * 60 * 1000, // 20min * 60s * 1000ms
            anzahlTestateProTerminblock: 6, // die Anzahl der Testate pro Terminblock
            anzahlGleichzeitigerTestate: 1, // kann hinterher noch leicht angepasst werden
        }`);

        function termineBerechnen() {
            let termine = [];
            for (let i = 0; i < 5; i++) {
                for (let j = 0; j < this.startZeiten.length; j++) {
                    for (let k = 0; k < this.anzahlTestateProTerminblock; k++) {
                        const zeit = Date.parse(`${this.startDatum}`)
                            + this.startZeiten[j] * 60 * 60 * 1000
                            + i * 24 * 60 * 60 * 1000 // Verschiebung um i Tage * 24h * 60min * 60s * 1000ms
                            + k * this.testatLänge // Verschiebung um k Testatlängen
                            - this.vorbereitungszeit; // Vor-Verschiebung um die Vorbereitungszeit
                        termine.push({
                            weekNumber: this.übungszettelnummer,
                            amount: this.anzahlGleichzeitigerTestate,
                            duration: this.testatLänge,
                            beginTime: zeit,
                            appointments: []
                        });
                    }
                }
            }
            return termine;
        }

        function debounce(func, wait, immediate) {
            var timeout;
            return function () {
                var context = this, args = arguments;
                var later = function () {
                    timeout = null;
                    if (!immediate) func.apply(context, args);
                };
                var callNow = immediate && !timeout;
                clearTimeout(timeout);
                timeout = setTimeout(later, wait);
                if (callNow) func.apply(context, args);
            };
        };

        window.preview = function() {
            let context;
            try {
                context = eval(window.editor.getValue());
            } catch (e) {
                return;
            }
            let preview = termineBerechnen.call(context).map(function (termin) {
                    let dateString = new Date(termin.beginTime).toLocaleDateString("de");
                    let fromString = new Date(termin.beginTime).toLocaleTimeString("de", {
                        hour: "2-digit",
                        minute: "2-digit"
                    });
                    let toString = new Date(termin.beginTime + termin.duration).toLocaleTimeString("de", {
                        hour: "2-digit",
                        minute: "2-digit"
                    });
                    return `<tr><td>${termin.weekNumber}</td><td>${dateString}</td><td>${fromString} - ${toString}</td><td>${termin.amount}</td></tr>`
                }
            )
            document.getElementById('preview').innerHTML = `<table><thead><th>Zettel</th><th>Datum</th><th>Zeit</th><th>Slots</th></thead>${preview}</table><br>`
        }
        window.termineHinzufügen = function() {
            let context;
            try {
                context = eval(window.editor.getValue());
            } catch (e) {
                alert("Error!");
                return;
            }
            let termine = termineBerechnen.call(context);
            console.log(termine);

            var xhr = new XMLHttpRequest();
            var url = "/api/addToSchedule";
            xhr.open("POST", url, true);
            xhr.setRequestHeader("Content-Type", "application/json");
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4 && xhr.status === 200) {
                    console.log("success");
                }
            };
            xhr.send(JSON.stringify(termine));
        }

        window.debouncedPreview = debounce(preview, 1000);

        editor.on('input', function () {
            debouncedPreview();
        });


